package de.fraunhofer.iem.dataprovider.dependency.dto

import de.fraunhofer.iem.dataprovider.dependency.entity.VulnerabilityEntity

data class VulnerabilityCreateDto(
    val cveIdentifier: String,
    val vulnerabilityScores: MutableList<VulnerabilityScoreCreateDto> = mutableListOf()
) {
    fun toDbObject(): VulnerabilityEntity {
        val vulnerabilityEntity = VulnerabilityEntity()
        vulnerabilityEntity.cveIdentifier = this.cveIdentifier

        vulnerabilityEntity.vulnerabilityScores = this.vulnerabilityScores.map { score ->
            val dbScore = score.toDbObject()
            dbScore.vulnerability = vulnerabilityEntity
            dbScore
        }.toMutableSet()

        return vulnerabilityEntity
    }
}
