package de.fraunhofer.iem.dataprovider.dependency.entity

import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "vulnerability")
class VulnerabilityEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @Column(name = "cve_identifier")
    var cveIdentifier: String? = null

    @ManyToOne
    @JoinColumn(name = "dependency_id")
    var dependency: DependencyEntity? = null

    @OneToMany(
        mappedBy = "vulnerability",
        cascade = [CascadeType.ALL],
        orphanRemoval = true
    )
    var vulnerabilityScores: MutableSet<VulnerabilityScoreEntity> = mutableSetOf()
    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as VulnerabilityEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}