package de.fraunhofer.iem.dataprovider.dependency.entity

import de.fraunhofer.iem.dataprovider.dependency.enumeration.VulnerabilityScoringSystemEnum
import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "vulnerability_score")
class VulnerabilityScoreEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @Column(name = "severity")
    var severity: String? = null

    @Enumerated(EnumType.STRING)
    @Column(name = "scoring_system")
    var scoringSystem: VulnerabilityScoringSystemEnum? = null

    @ManyToOne
    @JoinColumn(name = "vulnerability_id")
    var vulnerability: VulnerabilityEntity? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as VulnerabilityScoreEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}